/*
 *	dosio.c: part of oar(Object ARchiver)
 *	Copyright  1995  씎Y(oo), HGG00736@niftyserve.or.jp
 */
#include	"oar.h"
#include	<string.h>
#include	<limits.h>
#include	<sys/dos.h>
#include	<sys/iocs.h>
#include	"error.h"
#include	"istring.h"

int		old_archive = 1;
byte*	archive_buff = (byte*)0;
byte*	archive_ptr = (byte*)0;
byte*	old_archive_ptr = (byte*)0;
size_t	archive_size = 0;
size_t	archive_limit = 0;


byte* skip_dirs(byte* name)
{
	char*	p;
	extern unsigned char* mbsrchr(unsigned char*, int);

	/* hCuXLbv(蔲) */
	if (name[1] == ':') name += 2;

	/* fBNgXLbv */
	while ((p = mbsrchr(name, '/')) || (p = mbsrchr(name, '\\'))) name = ++p;

	/* t@C */
	return name;
}


void	check_null_device(void)
{
	int	mode;

	mode = _dos_ioctrlgt(fileno(stdout));
	if ((mode & 0x8000) && (mode & 4) && (mode & 3) == 0) {
		oar_term(0);
	}
}


static void	check_archive_header(byte* ptr)
{
	if (((lword*)ptr)[0] != ARC_HEADER1
	||  ( (word*)ptr)[2] != ARC_HEADER2) {
		fatal("A[JCuwb_(%04x:%04x:%04x)ُł",
			((word*)archive_buff)[0], ((word*)archive_buff)[1], ((word*)archive_buff)[2]);
	}
}


static void	scan_archive(byte* ptr, size_t size)
{
	size_t	objsize;
	name_t	objname;
	hash_s*	hashptr;
	header_s*	hp;
	header_s*	limit = (header_s*)(ptr + size);

	/*
	 *	ŏ̃IuWFNgwb_ւ̃|C^
	 */
	hp = (header_s*)(ptr + ARC_HEADSIZ);

	while (hp < limit) {
		objsize = hp->obj_size;
		objname = hp->obj_name;
		if (objsize == 0 || (objsize & 1)) {
			fatal("IuWFNg %s ̃TCY(%6x)ُł", objname, objsize);
		}
		if ((hashptr = hash_install(objname)) == (hash_s*)0) {
			fatal("nbVe[uς %s o^ł܂", objname);
		}
		if (name_install(objname, hashptr) == -1) {
			fatal("IuWFNge[uς %s o^ł܂", objname);
		}
		hp = (header_s*)((byte*)hp + HEADERSIZ + hp->obj_size);
	}
}


void	read_archive(int mode)
{
	int	fd;
	union _fcb*	fcbptr;

	if (mode) oar_init();

	archive_limit = (chkml() - BUFSIZ*2) & ~0x3ff;
	if ((archive_buff = (byte*)malloc(archive_limit)) == (byte*)0) {
		fatal("A[JCut@C %s ̃obt@mۂł܂", archive_path);
	}

	if ((fd = _dos_open(archive_path, 0)) < 0) {
		if (mode >= 2) {
			((lword*)archive_buff)[0] = ARC_HEADER1;
			( (word*)archive_buff)[2] = ARC_HEADER2;
			archive_ptr = archive_buff + (archive_size = ARC_HEADSIZ);
			old_archive = 0;
			return;
		}
		fatal("A[JCut@C %s I[vł܂", archive_path);
	}
	if ((int)(fcbptr = _dos_getfcb(fd)) <= 0) {
		fatal("A[JCut@C %s  fcb 擾ł܂", archive_path);
	}
	archive_size = _iocs_b_lpeek(&fcbptr->blk.size);
	if (archive_limit < archive_size) {
		fatal("A[JCut@C %s 傫܂", archive_path);
	}

	if (verbose) fprintf(stderr, "A[JCut@C %s ǂݍݒ...\n", archive_path);
	if (_dos_read(fd, archive_buff, archive_size) != archive_size) {
		fatal("A[JCut@C %s ǂݍ߂܂", archive_path);
	}
	if (verbose) fputs("I\n", stderr);
	_dos_close(fd);

	check_archive_header(archive_buff);
	if (mode) {
		scan_archive(archive_buff, archive_size);
	}
	archive_ptr = archive_buff + archive_size;
}


static void	scan_archive2(byte* ptr, size_t size)
{
	size_t	objsize;
	name_t	objname;
	hash_s*	hashptr;
	lword	time0, time1;
	header_s*	oldptr;
	header_s*	hp = (header_s*)ptr;
	header_s*	limit = (header_s*)(ptr + size);

	while (hp < limit) {
		objsize = hp->obj_size;
		objname = hp->obj_name;
		if (objsize == 0 || (objsize & 1)) {
			fatal("IuWFNg %s ̃TCY(%6x)ُł", objname, objsize);
		}
		if (hashptr = hash_lookup(objname)) {
			oldptr = (header_s*)hashptr->obj_name;
			if (force == 0) {
				time0 = *(lword*)&hp->obj_time;
				time1 = *(lword*)&oldptr->obj_time;
				asm("swap\t%0"::"d"(time0));
				asm("swap\t%0"::"d"(time1));

				/* ǂݍ񂾃t@C̕ÂꍇAȂ */
				if (time0 <= time1) {
					hp = (header_s*)((byte*)hp + HEADERSIZ + hp->obj_size);
					continue;
				}
			}

			/* TCYقȂƌԂł */
			if (objsize != oldptr->obj_size) ++delete_count;

			if (objsize <= oldptr->obj_size) {
				/*
				 *	VKIuWFNg̕
				 *	IuWFNg͓Ȃ̂ŃRs[Ȃ
				 */
				memcpy((byte*)oldptr + OBJNAME_MAX, (byte*)hp + OBJNAME_MAX,
						sizeof(header_s) - OBJNAME_MAX + objsize);
			}
			else {
				/*
				 *	VKIuWFNg̕傫̂ŁAŌɒǉ
				 */
				hashptr->obj_name = (name_t)hp;
				(hashptr->name_ptr)->obj_name = (name_t)hp;
			}
		}
		else {
			if ((hashptr = hash_install(objname)) == (hash_s*)0) {
				fatal("nbVe[uς %s o^ł܂", objname);
			}
			if (name_install(objname, hashptr) == -1) {
				fatal("IuWFNge[uς %s o^ł܂", objname);
			}
		}
		hp = (header_s*)((byte*)hp + HEADERSIZ + hp->obj_size);
	}
}


void	read_archive2(name_t name)
{
	int	fd;
	size_t	size;
	char	header[ARC_HEADSIZ];
	union _fcb*	fcbptr;

	if ((fd = _dos_open(name, 0)) < 0) {
		fatal("A[JCut@C %s I[vł܂", name);
	}
	if ((int)(fcbptr = _dos_getfcb(fd)) <= 0) {
		fatal("A[JCut@C %s  fcb 擾ł܂", name);
	}
	size = _iocs_b_lpeek(&fcbptr->blk.size) - ARC_HEADSIZ;
	if (archive_limit < archive_size + size) {
		fatal("A[JCut@C %s 傫܂", name);
	}

	if (verbose) fprintf(stderr, "A[JCut@C %s ǂݍݒ...\n", name);
	if (_dos_read(fd, header, sizeof header) != sizeof header) {
		fatal("A[JCut@C %s ̃wb_ǂݍ߂܂", name);
	}
	check_archive_header(header);
	if (_dos_read(fd, archive_ptr, size) != size) {
		fatal("A[JCut@C %s ǂݍ߂܂", name);
	}
	if (verbose) fputs("I\n", stderr);
	_dos_close(fd);

	scan_archive2(archive_ptr, size);
	archive_ptr += size;
}


int	read_object(name_t name)
{
	int	fd;
	byte*	src;
	byte*	dst;
	header_s*	ptr;
	union _fcb*	fcbptr;

	if ((fd = _dos_open(name, 0)) >= 0) {
		if ((int)(fcbptr = _dos_getfcb(fd)) <= 0) {
			fatal("IuWFNgt@C %s  fcb 擾ł܂", name);
		}
		/*
		 *	wb_쐬
		 */
		dst = (byte*)(ptr = (header_s*)archive_ptr);
		ptr->obj_size = _iocs_b_lpeek(&fcbptr->blk.size);
		if (archive_size + HEADERSIZ + ptr->obj_size >= archive_limit) {
			fatal("IuWFNgt@C %s ǂݍޗ]T܂", name);
		}
		*(lword*)&ptr->obj_time = _iocs_b_lpeek(&fcbptr->blk.time);

		((lword*)ptr)[0] = 0UL;
		((lword*)ptr)[1] = 0UL;
		((lword*)ptr)[2] = 0UL;
		((lword*)ptr)[3] = 0UL;
		((lword*)ptr)[4] = 0UL;
		((lword*)ptr)[5] = 0UL;

		/* I[vłƂƂ̓t@C 21 ȓ */
		src = skip_dirs((byte*)name);
		while (*dst++ = *src++);

		if (_dos_read(fd, (char*)(ptr + 1), ptr->obj_size) != ptr->obj_size) {
			fatal("IuWFNgt@C %s ̓ǂݍ݂ł܂", name);
		}
		_dos_close(fd);
		return 0;
	}
	return -1;
}


char*	temp_archive;

static char	temp_file[PATH_MAX+1];
static int	archive_fd;
static byte*	buff_ptr;
static byte*	base_ptr;
static byte*	next_ptr;
static size_t	area_size;

static void	ar_write(byte* ptr, size_t size)
{
	size_t	write_size;

	/* ̈悪AĂꍇ */
	if (ptr == next_ptr) {
		area_size += size;
		next_ptr += size;
		return;
	}

	/* ̈悪AĂȂꍇ */
	if (area_size >= BUFSIZ) {
		write_size = area_size - (area_size & (BUFSIZ - 1));
		if (_dos_write(archive_fd, base_ptr, write_size) != write_size) {
			fatal("ꎞt@C %s ݂̏Ɏs܂", temp_file);
		}
		if ((area_size -= write_size) == 0) {
			next_ptr = (base_ptr = ptr) + (area_size = size);
			return;
		}
		next_ptr = (base_ptr = memcpy(buff_ptr, base_ptr + write_size, area_size)) + area_size;
	}
	else if (base_ptr != buff_ptr) {
		next_ptr = (base_ptr = memcpy(buff_ptr, base_ptr, area_size)) + area_size;
	}
	if (area_size + size >= BUFSIZ) {
		memcpy(next_ptr, ptr, BUFSIZ - area_size);
		if (_dos_write(archive_fd, base_ptr, BUFSIZ) != BUFSIZ) {
			fatal("ꎞt@C %s ݂̏Ɏs܂", temp_file);
		}
		next_ptr = (base_ptr = ptr + (BUFSIZ - area_size))
		         + (area_size = size - (BUFSIZ - area_size));
	}
	else {
		memcpy(next_ptr, ptr, size);
		next_ptr += size;
		area_size += size;
	}
}


static void	ar_flush(void)
{
	if (area_size) {
		if (_dos_write(archive_fd, base_ptr, area_size) != area_size) {
			fatal("ꎞt@C %s ݂̏Ɏs܂", temp_file);
		}
	}
}


int	write_archive(void)
{
	header_s*	ptr;
	size_t	count;

	if (old_archive) {
		(void)_m_strcpy(temp_file, archive_path);
		temp_archive = _m_strcat(temp_file, "~");
	}
	else {
		(void)_m_strcpy(temp_file, archive_path);
	}

	if ((archive_fd = _dos_create(temp_file, 0x20)) < 0) {
		fatal("A[JCut@C %s 쐬ł܂", temp_file);
	}

	if (delete_count) {
		/*
		 *	A[JCut@Coő̖́AԂꍇłB
		 *
		 *	l@ƂĂ
		 *	1)  GAP SĖ߂Ăꊇŏo
		 *	2)  GAP OŃf[^ړsāANX^Pʂŏo
		 *	3)  IuWFNgPʂŃobt@O֐ɓn
		 *	4)  ʂȏꏊɃA[JCuč\zĂo
		 *
		 *	ł 2), 3) ̐ܒŏoƂɂ
		 */
		next_ptr = (base_ptr = archive_buff) + (area_size = ARC_HEADSIZ);
		if ((buff_ptr = (byte*)malloc(BUFSIZ)) == (byte*)0) {
			fatal("݃obt@mۂł܂");
		}
		for (count = 0; count < object_count; count++) {
			if ((ptr = (header_s*)object_names[count].obj_name) != (header_s*)0) {
				ar_write((byte*)ptr, ptr->obj_size + HEADERSIZ);
			}
		}
		ar_flush();
	}
	else {
		/* GAP Ȃ */
		if (_dos_write(archive_fd, archive_buff, archive_size) != archive_size) {
			fatal("A[JCut@C %s ݂̏Ɏs܂", temp_file);
		}
	}
	_dos_close(archive_fd);

	if (old_archive && _dos_delete(archive_path) < 0) {
		fatal("A[JCut@C %s 폜ł܂", archive_path);
	}
	if (old_archive && _dos_rename(temp_file, archive_path) < 0) {
		fatal("A[JCut@C %s ̖OύXł܂", temp_file);
	}
	temp_archive = (char*)0;
	return 0;
}


