/*
 *	name.c: part of oar(object archiver)
 *	Copyright  1994  씎Y(oo), HGG00736@niftyserve.or.jp
 */
#include	"oar.h"
#ifdef	HAVE_HMEMORY_H
#include	"hmemory.h"
#endif

#ifndef	OBJECT_LIMIT
#define	OBJECT_LIMIT	(0x1000)
#endif	/*OBJECT_LIMIT*/

name_s*	object_names = (name_s*)0;
size_t	object_count = 0;
size_t	object_limit = OBJECT_LIMIT;
size_t	delete_count = 0;


int		name_init(void)
{
#ifndef	HAVE_HMEMORY_H
	size_t	i;
	name_s*	ptr;
#endif

	if (object_names != (name_s*)0) return 0;
	if (object_names = (name_s*)malloc(object_limit*sizeof(name_s))) {
#ifdef	HAVE_HMEMORY_H
		_blkset((long*)object_names, (long)((name_t)0), (object_limit*sizeof(name_s))/256);
#else
		i = object_limit;
		ptr = object_names;
		while (i-- > 0) {
			ptr->obj_name = (name_t)0;
			ptr++;
		}
#endif
		return 0;
	}
	return -1;
}


void	name_term(void)
{
	if (object_names) free(object_names);
}


int	name_resize(name_t name, hash_s* hashptr)
{
	size_t	i;
	size_t	new_limit;
	name_s*	ptr;

	/*
	 *	SmۂĂ̂ŗ]
	 */
	new_limit = object_limit << 1;
	if (new_limit*sizeof(name_s) + 0x10 >= archive_limit - archive_size) {
		return -1;
	}
	archive_limit -= new_limit*sizeof(name_s) + 0x10;
	if ((void*)realloc(archive_buff, archive_limit) == (void*)0) {
		return -1;
	}

	if (object_names = (name_s*)realloc(object_names, new_limit*sizeof(name_s))) {
		for (ptr = object_names, i = object_count; --i >= 0; ptr++) {
			if (ptr->obj_name) (ptr->hash_ptr)->name_ptr = ptr;
		}
		object_limit = new_limit;
		object_names[object_count].obj_name = name;
		object_names[object_count].hash_ptr = hashptr;
		hashptr->name_ptr = object_names + object_count++;
		return 0;
	}
	return -1;
}


#ifdef	DEBUG
#include	<stdio.h>


void	name_dump(void)
{
	size_t	i;

	for (i = 0; i < object_count; i++) {
		fprintf(stderr, "%4x:%s\n", i, object_names[i].obj_name);
	}
}
#endif
