/*
 *	print.c: part of oar(Object ARchiver)
 *	Copyright  1995  씎Y(oo), HGG00736@niftyserve.or.jp
 */
#include	"oar.h"
#include	<sys/dos.h>
#include	"error.h"

static char	section[][8] = {
/*0xfc*/	"rcommon ",
/*0xfd*/	"rlcommon",
/*0xfe*/	"common  ",
/*0xff*/	"xref    ",
/*0x00*/	"abs     ",
/*0x01*/	"text    ",
/*0x02*/	"data    ",
/*0x03*/	"bss     ",
/*0x04*/	"stack   ",
/*0x05*/	"rdata   ",
/*0x06*/	"rbss    ",
/*0x07*/	"rstack  ",
/*0x08*/	"rldata  ",
/*0x09*/	"rlbss   ",
/*0x0a*/	"rlstack "
};

#define	SECTCNT	(sizeof section/8)


int	F_print(int ac, char** av)
{
	int		i;
	byte	cmd, sect;
	byte*	obj;
	byte*	src;
	byte*	dst;
	byte*	base;
	byte*	limit;
	header_s*	ptr;
	header_s*	end;

	if (chk_null) {
		check_null_device();
	}

	if (verbose && ac != 0) warning("R}h -p(--print-label) ͈Ƃ܂");

	if ((base = (byte*)malloc(BUFSIZ+256)) == (byte*)0) {
		fatal("o̓obt@mۂł܂");
	}
	limit = (dst = base) + BUFSIZ;

	read_archive(0);
	ptr = (header_s*)(archive_buff + ARC_HEADSIZ);
	end = (header_s*)(archive_buff + archive_size);

	while (ptr < end) {
		if ((i = dst - limit) >= 0) {
			_dos_write(fileno(stdout), base, BUFSIZ);
			for (dst = base, src = base + BUFSIZ; --i >= 0;) *dst++ = *src++;
		}

		/* IuWFNg̃Rs[ */
		src = ptr->obj_name;
		while (*dst++ = *src++);
		*(dst - 1) = '\r';
		*dst++ = '\n';

		obj = (byte*)(ptr + 1);
		while ((cmd = *obj) >= (byte)0xb0) {
			if ((i = dst - limit) >= 0) {
				_dos_write(fileno(stdout), base, BUFSIZ);
				for (dst = base, src = base + BUFSIZ; --i >= 0;) *dst++ = *src++;
			}

			switch (cmd) {
			case 0xb0:
				/* b0 ff      : label no.l : label : 0 : even (xref  label) */
			case 0xb2:
				/* b2 00      : abs.l      : label : 0 : even (xdef  label = abs     )
				   b2 sect.b  : adr.l      : label : 0 : even (xdef  label = sect:adr)
				   b2 {fc-fe} : size.l     : label : 0 : even (comm  label, size     )
				   b2 ff      : label no.l : label : 0 : even (xref  label           ) */
				/* 擪̋ */
				for (i = 8; --i >= 0;) *dst++ = ' ';
				/* V{l */
				if (long_form) {
					dst = ltoha(dst, (long*)(obj + 2));
					*dst++ = ' ';
					*dst++ = ' ';
				}
				/* ZNV */
				src = "unknown ";
				if ((sect = *(obj + 1) + 4) < (byte)SECTCNT) {
					src = section[sect];
				}
				for (i = 8; --i >= 0;) *dst++ = *src++;
				*dst++ = ' ';
				*dst++ = ' ';
				/* V{ */
				obj += 6;
				while (*dst++ = *obj++);
				*(dst - 1) = '\r';
				*dst++ = '\n';
				break;

			case 0xc0:
				/* c0 sect.b : sect_size.l : sect_name : 0 : even*/
				if (all_label && *(lword*)(obj + 2)) {
					/* 擪̋ */
					for (i = 8; --i >= 0;) *dst++ = ' ';
					/* V{lXLbv */
					if (long_form) {
						for (i = 10; --i >= 0;) *dst++ = ' ';
					}
					/* ZNV */
					src = "unknown ";
					if ((sect = *(obj + 1) + 4) < (byte)SECTCNT) {
						src = section[sect];
					}
					for (i = 8; --i >= 0;) *dst++ = *src++;
					*dst++ = ' ';
					*dst++ = ' ';
					/* ZNVTCY */
					dst = (*format)(dst, (long*)(obj + 2));
					*dst++ = '\r';
					*dst++ = '\n';
				}
				obj += 6;
				while (*obj++);
				break;

			case 0xd0:
				/* d0 00 : file_size.l  : file name : 0 : even*/
				if (all_label) {
					/* 擪̋ */
					for (i = 8; --i >= 0;) *dst++ = ' ';
					/* t@CTCY */
					if (long_form) {
						dst = ltoha(dst, (long*)(obj + 2));
						*dst++ = ' ';
						*dst++ = ' ';
					}
					/* ZNV=="filename" */
					src = "filename  ";
					while (*dst++ = *src++);
					--dst;
					/* t@C */
					obj += 6;
					while (*dst++ = *obj++);
					*(dst - 1) = '\r';
					*dst++ = '\n';
				}
				else {
					obj += 6;
					while (*obj++);
				}
				break;

			case 0xe0:
				/* e0 00 : sect.w : start_adr.l               (start_adr)
				   e0 01 : file_name : 0 : even               (request) */
				if ((sect = *(obj + 1)) > 1) {
					fatal("IuWFNgR}h e0:%02x ɂ͑ΉĂ܂", sect);
				}
				if (all_label) {
					/* 擪̋ */
					for (i = 8; --i >= 0;) *dst++ = ' ';
					/* V{lXLbv */
					if (long_form) {
						for (i = 10; --i >= 0;) *dst++ = ' ';
					}
					/* ZNV */
					src = (sect ? "request   " : "execute   ");
					while (*dst++ = *src++);
					--dst;
					/*  */
					if (sect) {
						obj += 2;
						while (*dst++ = *obj++);
						--dst;
					}
					else {
						dst = ltoha(dst, (long*)(obj + 4));
					}
					*dst++ = '\r';
					*dst++ = '\n';
				}
				else {
					if (sect) {
						obj += 2;
						while (*obj++);
					}
					else {
						obj += 8;
					}
				}
				break;

			default:
				fatal("IuWFNgR}h %02x ɂ͑ΉĂ܂", cmd);
				break;
			}
			if ((int)obj & 1) obj++;
		}
		ptr = (header_s*)((byte*)(ptr + 1) + ptr->obj_size);
	}
	if (dst - base > 0) {
		_dos_write(fileno(stdout), base, dst - base);
	}
	return 0;
}


